% Copyright Pieter Abbeel
%
% 3.7 Global Localization
%
% tic; p3_7_global_localization; toc
% Elapsed time is 1400.432946 seconds
% -- this was for "simple_world_path1", n_particles = 2000; 
%
clear; clc; close all;


% commenting in/out selects the world/sensory sequence to work with:

load simple_world_path1;
%load rooms_world_path1;
%load loops_world_path1;

% the ones below don't have the ground-truth.  Report results of your
% "best" run on these to show what you think the path of the robot was

%load simple_world_path2;
%load rooms_world_path2;
%load loops_world_path2;

% as a ball-park figure / starting point:
% for "simple_world"  (2000 particles, resampling 1000 uniformly at random,
% low-variance sampling, regularization with standard deviation 0.05 on
% each state variable), and downweighting the likelihood by first renormalizing (divide by the max likelihood 
% over all particles for that time slice) and then raising to power 0.05 worked well
%
% for the other worlds 5000 particles and 2500 resampled uniformly at
% random was insufficient; with my implementation only simple_world
% could be solved within a reasonable amount of time.


T = size(z,2);

%% visualize true path

figure; axis equal; hold on;
draw_gridworld(gridworld);
if(exist('x'))
	plot(x(1,:), x(2,:), 'x-');
end

[m,n] = size(gridworld);


%% run particle filter for localization


% YOUR code here



